<?php

namespace Webservice\Service\Dto\SmevSoap\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdaptationProgramType StructType
 * Meta information extracted from the WSDL
 * - documentation: Направленность группы
 * @subpackage Structs
 */
class AdaptationProgramType extends AbstractStructBase
{
    /**
     * The AdaptationGroup
     * @var \Webservice\Service\Dto\SmevSoap\StructType\DataElementType
     */
    public $AdaptationGroup;
    /**
     * The AdaptationGroupType
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \Webservice\Service\Dto\SmevSoap\StructType\DataElementType
     */
    public $AdaptationGroupType;
    /**
     * The AgreementOnGeneralGroup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $AgreementOnGeneralGroup;
    /**
     * The AgreementOnCareGroup
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $AgreementOnCareGroup;
    /**
     * The NeedSpecialCareConditions
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $NeedSpecialCareConditions;
    /**
     * Constructor method for AdaptationProgramType
     * @uses AdaptationProgramType::setAdaptationGroup()
     * @uses AdaptationProgramType::setAdaptationGroupType()
     * @uses AdaptationProgramType::setAgreementOnGeneralGroup()
     * @uses AdaptationProgramType::setAgreementOnCareGroup()
     * @uses AdaptationProgramType::setNeedSpecialCareConditions()
     * @param \Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroup
     * @param \Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroupType
     * @param bool $agreementOnGeneralGroup
     * @param bool $agreementOnCareGroup
     * @param bool $needSpecialCareConditions
     */
    public function __construct(\Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroup = null, \Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroupType = null, $agreementOnGeneralGroup = null, $agreementOnCareGroup = null, $needSpecialCareConditions = null)
    {
        $this
            ->setAdaptationGroup($adaptationGroup)
            ->setAdaptationGroupType($adaptationGroupType)
            ->setAgreementOnGeneralGroup($agreementOnGeneralGroup)
            ->setAgreementOnCareGroup($agreementOnCareGroup)
            ->setNeedSpecialCareConditions($needSpecialCareConditions);
    }
    /**
     * Get AdaptationGroup value
     * @return \Webservice\Service\Dto\SmevSoap\StructType\DataElementType|null
     */
    public function getAdaptationGroup()
    {
        return $this->AdaptationGroup;
    }
    /**
     * Set AdaptationGroup value
     * @param \Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroup
     * @return \Webservice\Service\Dto\SmevSoap\StructType\AdaptationProgramType
     */
    public function setAdaptationGroup(\Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroup = null)
    {
        $this->AdaptationGroup = $adaptationGroup;
        return $this;
    }
    /**
     * Get AdaptationGroupType value
     * @return \Webservice\Service\Dto\SmevSoap\StructType\DataElementType|null
     */
    public function getAdaptationGroupType()
    {
        return $this->AdaptationGroupType;
    }
    /**
     * Set AdaptationGroupType value
     * @param \Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroupType
     * @return \Webservice\Service\Dto\SmevSoap\StructType\AdaptationProgramType
     */
    public function setAdaptationGroupType(\Webservice\Service\Dto\SmevSoap\StructType\DataElementType $adaptationGroupType = null)
    {
        $this->AdaptationGroupType = $adaptationGroupType;
        return $this;
    }
    /**
     * Get AgreementOnGeneralGroup value
     * @return bool|null
     */
    public function getAgreementOnGeneralGroup()
    {
        return $this->AgreementOnGeneralGroup;
    }
    /**
     * Set AgreementOnGeneralGroup value
     * @param bool $agreementOnGeneralGroup
     * @return \Webservice\Service\Dto\SmevSoap\StructType\AdaptationProgramType
     */
    public function setAgreementOnGeneralGroup($agreementOnGeneralGroup = null)
    {
        // validation for constraint: boolean
        if (!is_null($agreementOnGeneralGroup) && !is_bool($agreementOnGeneralGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($agreementOnGeneralGroup, true), gettype($agreementOnGeneralGroup)), __LINE__);
        }
        $this->AgreementOnGeneralGroup = $agreementOnGeneralGroup;
        return $this;
    }
    /**
     * Get AgreementOnCareGroup value
     * @return bool|null
     */
    public function getAgreementOnCareGroup()
    {
        return $this->AgreementOnCareGroup;
    }
    /**
     * Set AgreementOnCareGroup value
     * @param bool $agreementOnCareGroup
     * @return \Webservice\Service\Dto\SmevSoap\StructType\AdaptationProgramType
     */
    public function setAgreementOnCareGroup($agreementOnCareGroup = null)
    {
        // validation for constraint: boolean
        if (!is_null($agreementOnCareGroup) && !is_bool($agreementOnCareGroup)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($agreementOnCareGroup, true), gettype($agreementOnCareGroup)), __LINE__);
        }
        $this->AgreementOnCareGroup = $agreementOnCareGroup;
        return $this;
    }
    /**
     * Get NeedSpecialCareConditions value
     * @return bool|null
     */
    public function getNeedSpecialCareConditions()
    {
        return $this->NeedSpecialCareConditions;
    }
    /**
     * Set NeedSpecialCareConditions value
     * @param bool $needSpecialCareConditions
     * @return \Webservice\Service\Dto\SmevSoap\StructType\AdaptationProgramType
     */
    public function setNeedSpecialCareConditions($needSpecialCareConditions = null)
    {
        // validation for constraint: boolean
        if (!is_null($needSpecialCareConditions) && !is_bool($needSpecialCareConditions)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($needSpecialCareConditions, true), gettype($needSpecialCareConditions)), __LINE__);
        }
        $this->NeedSpecialCareConditions = $needSpecialCareConditions;
        return $this;
    }
}
